How to print maximum number of A's using given four keys - GeeksforGeeks


How to print maximum number of A's using given four keys - GeeksforGeeks
Imagine you have a special keyboard with the following keys: Key 1: Prints 'A' on screen Key 2: (Ctrl-A): Select screen Key 3: (Ctrl-C): Copy selection to buffer Key 4: (Ctrl-V): Print buffer on screen appending it after what has already been printed. If you can only press the keyboard for N times (with the above four keys), write a program to produce maximum numbers of A's. That is to say, the input parameter is N (No. of keys that you can press), the output is M (No. of As that you can produce).
int findoptimal(int N)
{
    // The optimal string length is N when N is smaller than 7
    if (N <= 6)
        return N;
    // An array to store result of subproblems
    int screen[N];
    int b;  // To pick a breakpoint
    // Initializing the optimal lengths array for uptil 6 input
    // strokes.
    int n;
    for (n=1; n<=6; n++)
        screen[n-1] = n;
    // Solve all subproblems in bottom manner
    for (n=7; n<=N; n++)
    {
        // Initialize length of optimal string for n keystrokes
        screen[n-1] = 0;
        // For any keystroke n, we need to loop from n-3 keystrokes
        // back to 1 keystroke to find a breakpoint 'b' after which we
        // will have ctrl-a, ctrl-c and then only ctrl-v all the way.
        for (b=n-3; b>=1; b--)
        {
            // if the breakpoint is at b'th keystroke then
            // the optimal string would have length
            // (n-b-1)*screen[b-1];
            int curr = (n-b-1)*screen[b-1];
            if (curr > screen[n-1])
                screen[n-1] = curr;
        }
    }
    return screen[N-1];
}
Recursive:
int findoptimal(int N)
{
    // The optimal string length is N when N is smaller than 7
    if (N <= 6)
        return N;
    // Initialize result
    int max = 0;
    // TRY ALL POSSIBLE BREAK-POINTS
    // For any keystroke N, we need to loop from N-3 keystrokes
    // back to 1 keystroke to find a breakpoint 'b' after which we
    // will have Ctrl-A, Ctrl-C and then only Ctrl-V all the way.
    int b;
    for (b=N-3; b>=1; b--)
    {
            // If the breakpoint is s at b'th keystroke then
            // the optimal string would have length
            // (n-b-1)*screen[b-1];
            int curr = (N-b-1)*findoptimal(b);
            if (curr > max)
                max = curr;
     }
     return max;
}

http://articles.leetcode.com/2011/01/ctrla-ctrlc-ctrlv.html -- A little different from geeksforgeeks
int findMaxK(int n) {
    int power = 2;
    double max = 0.0;
    int maxK = 0;
    while (n > 0) {
        n -= 2;
        double t = (double)n/power;
        double r = pow(t, (double)power);
        if (r > max) {
            maxK = power;
            max = r;
        }
        power++;
    }
    return maxK;
}
unsigned int f(int n) {
    if (n <= 7) return n;
    int k = findMaxK(n);
    int sum = n - 2*(k-1);
    unsigned int mul = 1;
    while (k > 0) {
        int avg = sum/k;
        mul *= avg;
        k--;
        sum -= avg;
    }
    assert(sum == 0);
    return mul;
}

https://futurnist.wordpress.com/2012/05/22/1-a2-ctrla3-ctrlc/
When N is small, best strategy would be simply type A as much as possible.
When N is large, best strategy is to type A’s first and then start copy and paste. There’s no need to type A’s anymore after ^A is first pressed. Why? If another A is pressed after ^A is pressed, we can always swap these two key strokes and get a better solution, because we made one more letter in the clipboard by swapping.
When is a good time to update clipboard content by re-selecting everything? An upper bound is after a ^A^C^V action, it makes sense to press ^V at most 6 times. Original content is duplicated 7 times in this case. If you are allowed one more key stroke, the best option is NOT press ^V one more time and make an 8-th copy. Instead, the best option is (^A^C^V^V^V) followed by another cycle of itself. In the first cycle the original content is duplicated 3 times. In the second cycle the content is duplicated 9 times in total.

double from 4 steps before (^V pressed twice)
triple from 5 steps before (^V pressed three times)
4 times from 6 steps before
5 times from 7 steps before
6 times from 8 steps before
7 times from 9 steps before (^V pressed 6 times)
f(n) = max (
    2*f(n-4),
    3*f(n-5),
    4*f(n-6),
    5*f(n-7),
    6*f(n-8),
    7*f(n-9) //  (N-b-1)*findoptimal(b);
)
def f(N):
   li = [0, 1, 2, 3, 4, 5, 6, 7, 9]
   for i in range(9, N + 1):
      li.append(max(2*li[i-4], 3*li[i-5], 4*li[i-6], 5*li[i-7], 6*li[i-8], 7*li[i-9]))
   return li[N]
http://articles.leetcode.com/2011/01/ctrla-ctrlc-ctrlv.html
int findMaxK(int n) {
    int power = 2;
    double max = 0.0;
    int maxK = 0;
    while (n > 0) {
        n -= 2;
        double t = (double)n/power;
        double r = pow(t, (double)power);
        if (r > max) {
            maxK = power;
            max = r;
        }
        power++;
    }
    return maxK;
} 
unsigned int f(int n) {
    if (n <= 7) return n;
    int k = findMaxK(n);
    int sum = n - 2*(k-1);
    unsigned int mul = 1;
    while (k > 0) {
        int avg = sum/k;
        mul *= avg;
        k--;
        sum -= avg;
    }
    assert(sum == 0);
    return mul;
}
http://www.ideserve.co.in/learn/how-to-print-maximum-number-of-a-using-given-four-keys

1. For N < 7, the output is N itself. Please verify this yourself.
2. If you notice, to produce the maximum number of A's, the sequence of N keystrokes that will be used will end with a suffix of Ctrl-A, Ctrl-C, followed by only Ctrl-V's (For N > 6).
3. The task is to find out the critical-point after which we get the above suffix of keystrokes.
4. A critical-point is that instance after which we need to only press Ctrl-A, Ctrl-C once and the only Ctrl-V's afterwards to generate maximum number of A's.
5. We loop from N-3 to 1 and choose each of these values for the critical-point, and compute that optimal string they would produce. While computing optimal number of As for each critical point, we use optimal number of As already computed for number of keystrokes < N.
6. Once the above loop ends, we will have the maximum of the optimal lengths for various critical-points, thereby giving us the optimal length for N keystrokes.

    // assuming max input for 'n' won't be greater than 10.
    // you might want to change it according to your need.
    private static int MAX = 10;
     
    public static int findMaxAs(int n, int[] maxAsSolution)
    {
        if (n <= 6) return n;
        int maxSoFar = 0, maxAsWithThis_i = 0, multiplier = 2;
         
        for (int i = n-3; i >=0; i--)
        {
            if (maxAsSolution[i] == -1)
            {
                maxAsSolution[i] = findMaxAs(i, maxAsSolution);
            }
             
            maxAsWithThis_i = multiplier*maxAsSolution[i];
             
            if(maxAsWithThis_i > maxSoFar)
            {
                maxSoFar = maxAsWithThis_i;
            }
            multiplier +=1;
        }
        return maxSoFar;
    }

http://www.cnblogs.com/chkkch/archive/2012/11/04/2754297.html
打印这种类似最大结果的问题一般都会想到用DP
f[i][4]: 表示有四种方法,f[i][j] = max(f[i-1][k] + 各种操作)
如果要打印每个操作步骤,则要再设一个parent[i][j]数组,记录他的前任操作是哪个,然后递归调用。
http://www.careercup.com/question?id=7184083
Read full article from How to print maximum number of A's using given four keys - GeeksforGeeks

Labels

LeetCode (1432) GeeksforGeeks (1122) LeetCode - Review (1067) Review (882) Algorithm (668) to-do (609) Classic Algorithm (270) Google Interview (237) Classic Interview (222) Dynamic Programming (220) DP (186) Bit Algorithms (145) POJ (141) Math (137) Tree (132) LeetCode - Phone (129) EPI (122) Cracking Coding Interview (119) DFS (115) Difficult Algorithm (115) Lintcode (115) Different Solutions (110) Smart Algorithm (104) Binary Search (96) BFS (91) HackerRank (90) Binary Tree (86) Hard (79) Two Pointers (78) Stack (76) Company-Facebook (75) BST (72) Graph Algorithm (72) Time Complexity (69) Greedy Algorithm (68) Interval (63) Company - Google (62) Geometry Algorithm (61) Interview Corner (61) LeetCode - Extended (61) Union-Find (60) Trie (58) Advanced Data Structure (56) List (56) Priority Queue (53) Codility (52) ComProGuide (50) LeetCode Hard (50) Matrix (50) Bisection (48) Segment Tree (48) Sliding Window (48) USACO (46) Space Optimization (45) Company-Airbnb (41) Greedy (41) Mathematical Algorithm (41) Tree - Post-Order (41) ACM-ICPC (40) Algorithm Interview (40) Data Structure Design (40) Graph (40) Backtracking (39) Data Structure (39) Jobdu (39) Random (39) Codeforces (38) Knapsack (38) LeetCode - DP (38) Recursive Algorithm (38) String Algorithm (38) TopCoder (38) Sort (37) Introduction to Algorithms (36) Pre-Sort (36) Beauty of Programming (35) Must Known (34) Binary Search Tree (33) Follow Up (33) prismoskills (33) Palindrome (32) Permutation (31) Array (30) Google Code Jam (30) HDU (30) Array O(N) (29) Logic Thinking (29) Monotonic Stack (29) Puzzles (29) Code - Detail (27) Company-Zenefits (27) Microsoft 100 - July (27) Queue (27) Binary Indexed Trees (26) TreeMap (26) to-do-must (26) 1point3acres (25) GeeksQuiz (25) Merge Sort (25) Reverse Thinking (25) hihocoder (25) Company - LinkedIn (24) Hash (24) High Frequency (24) Summary (24) Divide and Conquer (23) Proof (23) Game Theory (22) Topological Sort (22) Lintcode - Review (21) Tree - Modification (21) Algorithm Game (20) CareerCup (20) Company - Twitter (20) DFS + Review (20) DP - Relation (20) Brain Teaser (19) DP - Tree (19) Left and Right Array (19) O(N) (19) Sweep Line (19) UVA (19) DP - Bit Masking (18) LeetCode - Thinking (18) KMP (17) LeetCode - TODO (17) Probabilities (17) Simulation (17) String Search (17) Codercareer (16) Company-Uber (16) Iterator (16) Number (16) O(1) Space (16) Shortest Path (16) itint5 (16) DFS+Cache (15) Dijkstra (15) Euclidean GCD (15) Heap (15) LeetCode - Hard (15) Majority (15) Number Theory (15) Rolling Hash (15) Tree Traversal (15) Brute Force (14) Bucket Sort (14) DP - Knapsack (14) DP - Probability (14) Difficult (14) Fast Power Algorithm (14) Pattern (14) Prefix Sum (14) TreeSet (14) Algorithm Videos (13) Amazon Interview (13) Basic Algorithm (13) Codechef (13) Combination (13) Computational Geometry (13) DP - Digit (13) LCA (13) LeetCode - DFS (13) Linked List (13) Long Increasing Sequence(LIS) (13) Math-Divisible (13) Reservoir Sampling (13) mitbbs (13) Algorithm - How To (12) Company - Microsoft (12) DP - Interval (12) DP - Multiple Relation (12) DP - Relation Optimization (12) LeetCode - Classic (12) Level Order Traversal (12) Prime (12) Pruning (12) Reconstruct Tree (12) Thinking (12) X Sum (12) AOJ (11) Bit Mask (11) Company-Snapchat (11) DP - Space Optimization (11) Dequeue (11) Graph DFS (11) MinMax (11) Miscs (11) Princeton (11) Quick Sort (11) Stack - Tree (11) 尺取法 (11) 挑战程序设计竞赛 (11) Coin Change (10) DFS+Backtracking (10) Facebook Hacker Cup (10) Fast Slow Pointers (10) HackerRank Easy (10) Interval Tree (10) Limited Range (10) Matrix - Traverse (10) Monotone Queue (10) SPOJ (10) Starting Point (10) States (10) Stock (10) Theory (10) Tutorialhorizon (10) Kadane - Extended (9) Mathblog (9) Max-Min Flow (9) Maze (9) Median (9) O(32N) (9) Quick Select (9) Stack Overflow (9) System Design (9) Tree - Conversion (9) Use XOR (9) Book Notes (8) Company-Amazon (8) DFS+BFS (8) DP - States (8) Expression (8) Longest Common Subsequence(LCS) (8) One Pass (8) Quadtrees (8) Traversal Once (8) Trie - Suffix (8) 穷竭搜索 (8) Algorithm Problem List (7) All Sub (7) Catalan Number (7) Cycle (7) DP - Cases (7) Facebook Interview (7) Fibonacci Numbers (7) Flood fill (7) Game Nim (7) Graph BFS (7) HackerRank Difficult (7) Hackerearth (7) Inversion (7) Kadane’s Algorithm (7) Manacher (7) Morris Traversal (7) Multiple Data Structures (7) Normalized Key (7) O(XN) (7) Radix Sort (7) Recursion (7) Sampling (7) Suffix Array (7) Tech-Queries (7) Tree - Serialization (7) Tree DP (7) Trie - Bit (7) 蓝桥杯 (7) Algorithm - Brain Teaser (6) BFS - Priority Queue (6) BFS - Unusual (6) Classic Data Structure Impl (6) DP - 2D (6) DP - Monotone Queue (6) DP - Unusual (6) DP-Space Optimization (6) Dutch Flag (6) How To (6) Interviewstreet (6) Knapsack - MultiplePack (6) Local MinMax (6) MST (6) Minimum Spanning Tree (6) Number - Reach (6) Parentheses (6) Pre-Sum (6) Probability (6) Programming Pearls (6) Rabin-Karp (6) Reverse (6) Scan from right (6) Schedule (6) Stream (6) Subset Sum (6) TSP (6) Xpost (6) n00tc0d3r (6) reddit (6) AI (5) Abbreviation (5) Anagram (5) Art Of Programming-July (5) Assumption (5) Bellman Ford (5) Big Data (5) Code - Solid (5) Code Kata (5) Codility-lessons (5) Coding (5) Company - WMware (5) Convex Hull (5) Crazyforcode (5) DFS - Multiple (5) DFS+DP (5) DP - Multi-Dimension (5) DP-Multiple Relation (5) Eulerian Cycle (5) Graph - Unusual (5) Graph Cycle (5) Hash Strategy (5) Immutability (5) Java (5) LogN (5) Manhattan Distance (5) Matrix Chain Multiplication (5) N Queens (5) Pre-Sort: Index (5) Quick Partition (5) Quora (5) Randomized Algorithms (5) Resources (5) Robot (5) SPFA(Shortest Path Faster Algorithm) (5) Shuffle (5) Sieve of Eratosthenes (5) Strongly Connected Components (5) Subarray Sum (5) Sudoku (5) Suffix Tree (5) Swap (5) Threaded (5) Tree - Creation (5) Warshall Floyd (5) Word Search (5) jiuzhang (5)

Popular Posts